config/routes.rb
Rails.application.routes.draw do
  mount Ckeditor::Engine => '/ckeditor'
  devise_for :users, controllers: {registrations: "registrations"}
  post 'likes/create'
  post 'likes/destroy'
  post 'dislikes/create'
  post 'dislikes/destroy'
  post 'comments/reply'
  post 'comments/approve'
  get 'post/my', to: 'posts#my', as: :my_posts
  get 'posts/index', to: 'posts#index', as: :post_index

  resources :posts do
    resources :comments
    resources :ratings
  end

  resources :admin do
    resources :tags

    root to: "tags#index"
  end

  resources :tags
  resources :users

  root 'posts#index'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/comment.rb
class Comment < ApplicationRecord
  acts_as_tree order: 'created_at DESC'
  belongs_to :user
  belongs_to :post #, dependent: :destroy
  has_many :like, dependent: :destroy
  has_many :dislike, dependent: :destroy

  validates :title, presence: {message: "Missing title"}
  validates :content, presence: {message: "Missing content"}

  before_save :generate_timestamp

  def generate_timestamp
    self.added = DateTime.now
  end

  def likes_count
    self.like.count()
  end

  def can_like id
    self.like.where(user_id: id).empty?
  end

  def dislikes_count
    self.dislike.count()
  end

  def can_dislike id
    self.dislike.where(user_id: id).empty?
  end

end

app/models/dislike.rb
class Dislike < ApplicationRecord
  belongs_to :user
  belongs_to :comment
end

app/models/like.rb
class Like < ApplicationRecord
  belongs_to :user
  belongs_to :comment
end

app/models/post.rb
class Post < ApplicationRecord
  has_attached_file :image, styles: { large: "900x900>", medium: "500x500>", thumb: "100x100>" }
  validates_attachment_content_type :image, content_type: /\Aimage\/.*\z/


  has_many :comments, dependent: :destroy

  has_many :ratings, dependent: :destroy
  has_and_belongs_to_many :tags

  belongs_to :user

  has_one :post_option

  validates :title, presence: {message: "Missing title"}
  validates :perex, presence: {message: "Missing perex"}
  validates :text, presence: {message: "Missing text"}

  before_save :generate_timestamp
  before_create :build_associations

  def generate_timestamp
    self.added = DateTime.now
  end

  def assign_params_from_controller(params)
    @option_params = params
  end

  def build_associations
    #PostOption.new(@option_params).save
    self.post_option = PostOption.new(@option_params)
  end

  def primary_comments
    self.comments.where(parent_id: nil, approved: true).order(created_at: :desc)
  end

  def not_allowed_comments_for_current_user id
    self.comments.where(user_id: id, approved: false).order(created_at: :desc)
  end

  def not_allowed_comments
    self.comments.where(approved: false).order(created_at: :desc)
  end

end

app/models/post_option.rb
class PostOption < ApplicationRecord
end

app/models/rating.rb
class Rating < ApplicationRecord
  belongs_to :user
  belongs_to :post
  validates :value, numericality: { only_integer: true }, inclusion: { :in => [ 1, 2, 3, 4, 5 ] }
end

app/models/tag.rb
class Tag < ApplicationRecord
  has_and_belongs_to_many :posts
  validates :name, presence: {message: "Missing name of tag"}

end

app/models/under_comment.rb
class UnderComment < ApplicationRecord
  belongs_to :comment, dependent: :destroy
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable, :confirmable
  has_many :posts
end

app/controllers/admin/tags_controller.rb
class Admin::TagsController < Admin::BaseController
  
  def index
     @tags = Tag.all
     # @users = User.all
  end    

end  

app/controllers/likes_controller.rb
class LikesController < ApplicationController

  def new
    @like = Like.new(like_params)
  end

  def create

    @post = Post.find(params[:post_id])

    #destroy dislike if exists
    @dislikes = Dislike.where(user_id: params[:user_id],comment_id: params[:comment_id])
    unless @dislikes.empty?
      @dislikes.first.destroy
    end

    @like = Like.new(like_params)
    @comment = Comment.find(params[:comment_id])
    @like.save

    respond_to do |format|
      format.js
    end
  end

  def destroy

    @post = Post.find(params[:post_id])
    @like = Like.where(user_id: params[:user_id],comment_id: params[:comment_id]).take
    @like.destroy

    respond_to do |format|
      format.js
    end

  end

  private
  def like_params
    params.permit(:user_id, :comment_id)
  end

end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  # before_action :authenticate_user!

  def index

    if params[:tag]
      #filtered public posts
      @posts = public_posts.joins(:tags).where('name LIKE ?', "%#{params[:tag]}%")
    else
      #all public posts
      @posts = public_posts
    end
  end

  def show
    @post = Post.find(params[:id])
  end

  def new
    @post = Post.new
  end

  def edit
    @post = Post.find(params[:id])
  end

  def create
    @post = Post.new(post_params)
    @post.assign_params_from_controller(post_option_params)

    if @post.save
      redirect_to @post
    else
      #redirect back
      redirect_back fallback_location: root_path

      #show error message
      @post.errors.messages.each do |msg|
        flash[:warning] = msg.second
      end
    end
  end

  def update
    @post = Post.find(params[:id])

    if @post.update(post_params) and @post.post_option.update(post_option_params)
      redirect_to @post
    else
      render 'edit'
    end
  end

  def destroy
    @post = Post.find(params[:id])
    @post.destroy

    redirect_to posts_path
  end

  def my
    @current_user_posts = Post.joins(:user).where('users.id = ?', current_user.id)
  end

  private
  def post_params
    params.require(:post).permit(:title, :perex, :text, :added, :image, :user_id, :tag_ids => [])
  end

  def post_option_params
    params.require(:post_options).permit(:public, :comments_allowed, :comment_needs_approval)
  end

  def public_posts
    Post.joins(:post_option).where('post_options.public = true')
  end


end

app/controllers/tags_controller.rb
class TagsController < ApplicationController
  before_action :authenticate_user!

  def index
      @tags = Tag.all

  end

  ### show detail of tag
  def show
      @tag = Tag.find(params[:id])
  end

  ### new tag
  def new
    if current_user.admin?
      @tag = Tag.new
    else
       redirect_to root_path
    end
  end

  ### edit tag
  def edit
    if current_user.admin?
      @tag = Tag.find(params[:id])
    else
       redirect_to root_path
    end
  end

  ### create new tag
  def create
    if current_user.admin?
      @tag = Tag.new(tag_params)

      if @tag.save
        redirect_to @tag
      else
        #redirect back
        redirect_back fallback_location: root_path

        #show error message
        @tag.errors.messages.each do |msg|
          flash[:warning] = msg.second
        end
      end
    else
       redirect_to root_path
    end
  end

  ### update tag
  def update
    if current_user.admin?
      @tag = Tag.find(params[:id])

      if @tag.update(tag_params)
        redirect_to @tag
      else
        render 'edit'
      end
    else
       redirect_to root_path
    end
  end

  ### destroy chosen tag
  def destroy
    if current_user.admin?
      @tag = Tag.find(params[:id])
      @tag.destroy

      redirect_to tags_path
    else
       redirect_to root_path
    end
  end

  ### tag parameters
  private
  def tag_params
    params.require(:tag).permit(:name)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/dislikes_helper.rb
module DislikesHelper
end

app/helpers/likes_helper.rb
module LikesHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/helpers/ratings_helper.rb
module RatingsHelper
end

app/helpers/tag_posts_helper.rb
module TagPostsHelper
end

app/helpers/tags_helper.rb
module TagsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/tags/edit.html.erb
<div class="main-wrapper">
<div class="h1-block">
  <h1>EDIT TAG</h1>
</div> 

<%= form_with(model: @tag) do |form| %>

  <% if @tag.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@tag.errors.count, "error") %> prohibited
        this tag from being saved:
      </h2>
      <ul>
        <% @tag.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group">
    <%= form.label :name %><br>
    <%= form.text_field :name, :class=> "form-control" %>
  </div>

  <div>
    <%= form.submit 'Save changes', :class => 'btn btn-lg btn-black' %>
  </div>

<% end %>



<%= link_to tags_path, class: "btn btn-back" do %>
  <span class="glyphicon glyphicon-arrow-left"></span> Back
<% end %>
<p></p>
</div>

app/views/tags/index.html.erb
<div class="main-wrapper">
<div class="h1-block">
  <h1>ALL TAGS</h1>
</div>

  <% if current_user.admin? %>
    <%= link_to 'New tag', new_tag_path, class: "btn btn-green" %><br/><br/>
  <%end%>

<table class="table">
  <thead>
    <tr>
      <th>Name</th>
      <!-- <th colspan="1"></th> -->
    </tr>
  </thead>
  <tbody>
  <% @tags.each do |tag| %>
    <tr>
      <td><%= tag.name %></td>
      <td><%= link_to 'Show posts', tag_path(tag) %></td>

      <% if current_user.admin? %>
        <td><%= link_to 'Edit', edit_tag_path(tag) %></td>
        <td><%= link_to 'Delete', tag_path(tag),
                        method: :delete,
                        data: { confirm: 'Are you sure?' } %></td>
      <%end%>
    </tr>
  <% end %>
  </tbody>
</table>

</div>

app/views/tags/new.html.erb
<div class="main-wrapper">
<div class="h1-block">
  <h1>ADD NEW TAG</h1>
</div> 
<%= form_with scope: :tag, url: tags_path, local: true do |form| %>

  <% if @tag.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@tag.errors.count, "error") %> prohibited
        this tag from being saved:
      </h2>
      <ul>
        <% @tag.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group">
    <%= form.label :name %><br>
    <%= form.text_field :name, :class=> "form-control" %>
  </div>

  <div>
    <%= form.submit 'Add new tag', :class => 'btn btn-lg btn-black' %>
  </div>

<% end %>



<%= link_to tags_path, class: "btn btn-back" do %>
  <span class="glyphicon glyphicon-arrow-left"></span> Back
<% end %>
<p></p>
</div>

app/views/tags/show.html.erb
<div class="main-wrapper">
<div class="h1-block">
  <h1> Detail of <%= @tag.name %></h1>
</div>

  <% if current_user.admin? %>
    <%= link_to 'Edit tag', edit_tag_path(@tag), class: "btn btn-green" %><br/><br/>
  <%end%>

<!-- POSTS OF THIS TAG -->
<h2>Posts of this tag</h2>
<div class="row">
  <% @tag.posts.each do |post| %>
    <div class="col-xs-6 col-md-3">
      <div class="thumbnail">
        <% unless post.image_file_name.nil? %>
          <%= link_to post_path(post) do %>
            <%= image_tag post.image.url(:medium) %>
          <% end %>  
        <% end %>
        <div class="small-sp-card"><%= link_to post.title, post_path(post), :class=> "black" %></div>
      </div>
    </div>
  <% end %>
</div>

<!-- BACK TO TAGS  -->
<%= link_to tags_path, class: "btn btn-back" do %>
  <span class="glyphicon glyphicon-arrow-left"></span> Back
<% end %>
</div>